#ifndef _XRLOG_H_
#define _XRLOG_H_

#include <sys/types.h>

#define XRLOG_ERR_MAX_WRITE_SIZE_EXCEEDED	-1
#define XRLOG_ERR_INVALID_DATA_ACCESS		-2

// log ring buffer
typedef struct xrlog_s xrlog_t;

short xrlog_write(xrlog_t* xrlog, u_char* data_buf, u_short len);

u_short xrlog_get_first_byte(xrlog_t* xrlog);

u_short xrlog_get_curr_pos(xrlog_t* xrlog);

short xrlog_read(xrlog_t* xrlog, u_char* data_buf, u_short* pos, u_short len);

short xrlog_seek(xrlog_t* xrlog, u_short* pos, short offset);

void xrlog_empty(xrlog_t* xrlog);

xrlog_t* xrlog_init(u_long mem_addr, u_short max_size);

#endif //_XRLOG_H_
